/* ===========================================================================
                           TTB Plugin Template(VC++)

                                 Main.cpp

   =========================================================================== */
#include "Windows.h"
#include <shlwapi.h>

#include "Main.h"
#include "MessageDef.h"

#include <stdio.h>
#include <time.h>

#define LIST_MAX	100
#define WND_CLASS TEXT("AltTabMouse")
#define IDM_SETFOREGROUND	10001

// --------------------------------------------------------
//    R}h̏
// --------------------------------------------------------
PLUGIN_COMMAND_INFO	COMMAND_INFO[COMMAND_COUNT] = {
	{
		"enable/disable",					// R}hipj
		"L/̐؂ւ",				// R}hi{j
		COMMAND1_ID,				// R}hID
		0,							// Attrigpj
		-1,							// ResTd(gpj
		dmHotKeyMenu,
									// DispMenu
		0,							// TimerInterval[msec] 0ŎgpȂ
		0							// TimerCounterigpj
	}
};

HHOOK	g_hMouseHook = NULL;
HINSTANCE g_hInst;
BOOL	g_isMouse = FALSE;
BOOL	g_isScroll = FALSE;
HWND	g_hWnd = NULL;
HANDLE	g_hThread = NULL;
DWORD	g_ThreadID = NULL;
int		g_winWidth = 150;
int		g_winHeight = 300;
int		g_fontHeight = 12;
int		g_iconHeight = 16;
int		g_winPosX = 0;
int		g_winPosY = 0;
UINT	g_waitTime = 500;	//ms
UINT	g_WM_sBUTTONDOWN;
UINT	g_WM_sBUTTONUP;
UINT	g_WM_eBUTTONDOWN;
UINT	g_WM_eBUTTONUP;
HANDLE	g_hEvent = NULL;
HANDLE	g_hWaitThread = NULL;
BOOL	g_isLog = TRUE;
BOOL	g_isWheel, g_isClick;
char	g_fontName[] = "MS UI GOTHIC";
typedef struct
{
	char name[500];
	HWND hWnd;
	HICON hIcon;
} WLIST;
WLIST wList[LIST_MAX];
int	wListNum = 0;
int wListCnt = 0;
HWND hw[LIST_MAX];
unsigned long st[LIST_MAX], exst[LIST_MAX];
int hw_cnt = 0;

#define isStyle(s, ss)	((s & ss) != 0)

void Log(char *str)
{
	if (g_isLog == FALSE) {
		return;
	}
	WriteLog(elDebug, str);
	return;
}
void LogStatus()
{
	if (g_isLog == FALSE) return;
	HWND hWnd = NULL;
	char c[1024], text[1024];
	hWnd = GetForegroundWindow();
	if (hWnd != NULL) {
		GetClassName(hWnd, c, sizeof c);
		sprintf(text, "ForegroundWindow:%s:%x", c, hWnd);
		Log(text);
	} else {
		Log("ForegroundWindow:NULL");
	}
	return;
}

DWORD WINAPI WaitTimeFunc(LPVOID lp) {
	if (g_waitTime == 0) {
		CloseHandle(g_hWaitThread);
		g_hWaitThread = NULL;
		return 0;
	}
	DWORD d = WaitForSingleObject(g_hEvent, g_waitTime);
	CloseHandle(g_hWaitThread);
	g_hWaitThread = NULL;
	switch (d) {
		case WAIT_TIMEOUT:
			g_isMouse = FALSE;
			g_isScroll = FALSE;
			break;
		case WAIT_OBJECT_0:
//			MessageBox(NULL, "Signal", "Sig", MB_OK);
			break;
		default:
			break;
	}
	return 0;
}

void getSizeByList(int *width, int *height)
{
	unsigned int len = 150, tlen;
	int i;
	if (g_iconHeight > 0 && g_iconHeight > g_fontHeight) {
		*height = 10+g_iconHeight*wListNum;
	} else {
		*height = 10+g_fontHeight*wListNum;
	}
	HDC hdc;
	SIZE size;
	PAINTSTRUCT paint;
	HFONT hFontOld, hFontHigh = CreateFont(	g_fontHeight, 0, 0, 0, FW_BOLD, 
						FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
						OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						PROOF_QUALITY, FIXED_PITCH | FF_MODERN, g_fontName);
	hdc = BeginPaint(g_hWnd, &paint);
	hFontOld = (HFONT)SelectObject(hdc, hFontHigh);
	for (i=0;i<wListNum;i++) {
		GetTextExtentPoint32(hdc, wList[i].name, strlen(wList[i].name), &size);
		tlen = size.cx;
		if (tlen > len) {
			len = tlen;
		}
	}
	SelectObject(hdc, hFontOld);
	DeleteObject(hFontHigh);
	EndPaint(g_hWnd, &paint);
	*width = len + g_iconHeight + 15;
}

void getPositionBySize(int *x, int *y, int width, int height)
{
	HWND hDesk;
	RECT rcDesk;
	int dw, dh;
	char gaga[500];
	
	hDesk = GetDesktopWindow();
	GetWindowRect(hDesk, (LPRECT)&rcDesk);
	*x = (rcDesk.right - width) / 2;
	*y = (rcDesk.bottom - height) / 5 * 2;
	return;
}

void getPositionOffsetByMousePos(int *x, int *y, POINT mpt)	//fAfBXvCz(2̂ݓmF)
{
	RECT rcDesk;
	*x = 0;*y = 0;

	GetWindowRect(GetDesktopWindow(), (LPRECT)&rcDesk);
	if (mpt.x > rcDesk.right) {
		*x = rcDesk.right;
	}
	if (mpt.y > rcDesk.bottom) {
		*y = rcDesk.bottom;
	}
}

BOOL CALLBACK EnumProc(HWND hWnd, LPARAM lp)
{
	if (!IsWindowVisible(hWnd)) {
		return TRUE;
	}
	hw[hw_cnt] = hWnd;
	st[hw_cnt] = GetWindowLong(hWnd, GWL_STYLE);
	exst[hw_cnt] = GetWindowLong(hWnd, GWL_EXSTYLE);
	hw_cnt++;
	return TRUE;
}
HWND GetTopOwner(HWND hWnd)
{
	while (GetWindow(hWnd, GW_OWNER) != NULL) {
		hWnd = GetWindow(hWnd, GW_OWNER);
	}
	return hWnd;
}

void ListupWindow()
{
	int i, j;
	char title[500], ctitle[500];
	HWND hh;
	unsigned long ss;
	
	if (wListNum > 0) {
		return;
	}
	
	hw_cnt = 0;
	EnumWindows(EnumProc, NULL);
	for (i=0;i<hw_cnt;i++) {
		if (GetWindow(hw[i], GW_OWNER) == NULL) {
			if (!GetParent(hw[i])) {
				if (!isStyle(exst[i], WS_EX_TOOLWINDOW)) {
					wList[wListNum++].hWnd = hw[i];
				}
			}
		}
		GetClassName(hw[i], ctitle, sizeof(ctitle));
		if (strcmp(ctitle, "#32770") == 0) {
			hh = GetTopOwner(hw[i]);
			ss = GetWindowLong(hh, GWL_STYLE);
			if ( !isStyle(ss, WS_VISIBLE) ) {
				wList[wListNum++].hWnd = hw[i];
			}
		}
	}
	for (i=0;i<hw_cnt;i++) {
		if (!isStyle(st[i], WS_DISABLED)) {
			if (isStyle(st[i], WS_VISIBLE)) {
				if (!isStyle(exst[i], WS_EX_TOOLWINDOW)) {
					hh = GetTopOwner(hw[i]);
					for (j=0;j<wListNum;j++) {
						if (hh == wList[j].hWnd) {
							wList[j].hWnd = hw[i];
						}
					}
				}
			}
		}
	}
	hh = GetForegroundWindow();
	for (i=0,j=1;i<wListNum;i++) {
		if (wList[i].hWnd == hh) {
			wListCnt = i;
		}
		GetWindowText(wList[i].hWnd, wList[i].name, sizeof(wList[i].name));
		wList[i].hIcon = (HICON)(HICON)GetClassLong(wList[i].hWnd, GCL_HICONSM);
		if (wList[i].hIcon == 0) {
			wList[i].hIcon = (HICON)SendMessage(wList[i].hWnd, WM_GETICON, ICON_BIG, 0);
		}
	}
	
	getSizeByList(&g_winWidth, &g_winHeight);
	getPositionBySize(&g_winPosX, &g_winPosY, g_winWidth, g_winHeight);
}

void FreeIcon(int num)
{
	int i;
	for (i=0;i<num;i++) {
		DestroyIcon(wList[i].hIcon);
	}
}

BOOL SetForeground(HWND hWnd)	//http://www4.cds.ne.jp/~neg/pro/piyo1/osetc/setfw.html
								//http://d.hatena.ne.jp/gsf_zero1/20071211/p1
{
	DWORD tID, hID;
	DWORD flt;
	
	tID = GetWindowThreadProcessId(hWnd, NULL);
	hID = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	
	if (IsIconic(hWnd) != 0) {
		ShowWindow(hWnd, SW_RESTORE);
	}

	for (int i=0;i<10;i++) {
	SetActiveWindow(hWnd);
	SetForegroundWindow(hWnd);
	if (tID == hID) {
		BringWindowToTop(hWnd);
//		SetForegroundWindow(hWnd);
	} else {
		AttachThreadInput(tID, hID, true);
//		SetForegroundWindow(hWnd);
		BringWindowToTop(hWnd);
		SetActiveWindow(hWnd);
		AttachThreadInput(tID, hID, false);
	}
		if (GetForegroundWindow() == hWnd)
			break;
		else
			Log("foreground error");
	}
	
	return TRUE;
	
}

LRESULT CALLBACK LowLevelMouseProc(int nCode, WPARAM wp, LPARAM lp)
{
	LPMSLLHOOKSTRUCT pmh;
	int offsetX, offsetY;
	if (nCode < 0) {
		return CallNextHookEx(g_hMouseHook, nCode, wp, lp);
	}
	pmh = (LPMSLLHOOKSTRUCT)lp;
	char temp[1000];
	DWORD did;
	if (wp == g_WM_sBUTTONDOWN) {
		g_isMouse = TRUE;
		wListCnt = 0;
		FreeIcon(wListNum);
		wListNum = 0;
		ResetEvent(g_hEvent);
		g_hWaitThread = CreateThread(NULL , 0 , WaitTimeFunc , NULL , 0 , &did);
	} else if (wp == g_WM_sBUTTONUP) {
		g_isMouse = FALSE;
		SetEvent(g_hEvent);
		if (g_isScroll) {
			g_isScroll = FALSE;
			ShowWindow(g_hWnd, SW_HIDE);
			SendMessage(g_hWnd, WM_COMMAND, MAKEWPARAM(IDM_SETFOREGROUND, 0), 0);
		}
	} else if ((wp == g_WM_eBUTTONDOWN && g_isClick == 1) || (wp == WM_MBUTTONDOWN && g_isWheel == 1)) {
		if (g_isMouse && g_isScroll) {
			SetEvent(g_hEvent);
			g_isScroll = FALSE;
			ShowWindow(g_hWnd, SW_HIDE);
			SendMessage(g_hWnd, WM_COMMAND, MAKEWPARAM(IDM_SETFOREGROUND, 0), 0);
			ResetEvent(g_hEvent);
			g_hWaitThread = CreateThread(NULL , 0 , WaitTimeFunc , NULL , 0 , &did);
			return TRUE;
		}
	} else if (wp == WM_MOUSEWHEEL) {
		if (g_isMouse) {
			SetEvent(g_hEvent);
			ListupWindow();
			g_isScroll = TRUE;
			getPositionOffsetByMousePos(&offsetX, &offsetY, pmh->pt);
			SetWindowPos(g_hWnd, HWND_BOTTOM, offsetX+g_winPosX, offsetY+g_winPosY, g_winWidth, g_winHeight, SWP_SHOWWINDOW);
			short delta = HIWORD(pmh->mouseData);
			if (delta > 0) {	//Up
				wListCnt--;
			} else if (delta < 0) {	//Down
				wListCnt++;
			}
			if (wListCnt < 0) {
				wListCnt = wListNum-1;
			} else if (wListCnt >= wListNum) {
				wListCnt = 0;
			}
			InvalidateRect(g_hWnd, NULL, TRUE);
			return TRUE;
		}
	}
	return CallNextHookEx(g_hMouseHook, nCode, wp, lp);
}

void showWinList(HWND hWnd)
{
	HDC hdc;
	PAINTSTRUCT paint;
	HFONT hFont, hFontOld, hFontHigh;
	HICON hIcon;
	int i;
	const int head = 5;
	int newHeight, iconOffset, fontOffset;
	if (g_iconHeight > 0 && g_iconHeight > g_fontHeight) {
		newHeight = g_iconHeight;
		iconOffset = 0;
		fontOffset = (newHeight - g_fontHeight)/2;
	} else {
		newHeight = g_fontHeight;
		iconOffset = (newHeight - g_iconHeight)/2;
		fontOffset = 0;
	}
	
	hFont = CreateFont(	g_fontHeight, 0, 0, 0, FW_NORMAL, 
						FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
						OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						PROOF_QUALITY, FIXED_PITCH | FF_MODERN, g_fontName);
	hFontHigh = CreateFont(	g_fontHeight, 0, 0, 0, FW_BOLD, 
						FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
						OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						PROOF_QUALITY, FIXED_PITCH | FF_MODERN, g_fontName);
	hdc = BeginPaint(hWnd, &paint);
	hFontOld = (HFONT)SelectObject(hdc, hFont);
	for (i=0;i<wListNum;i++) {
		if (g_iconHeight > 0) {
			DrawIconEx(hdc, head, head+newHeight*i+iconOffset, wList[i].hIcon, g_iconHeight, g_iconHeight, NULL, NULL, DI_NORMAL);
		}
		if (i == wListCnt) {
			SelectObject(hdc, hFontHigh);
			TextOut(hdc, head+g_iconHeight+head, head+newHeight*i+fontOffset, (LPCSTR)wList[i].name, strlen(wList[i].name));
			SelectObject(hdc, hFont);
		} else {
			TextOut(hdc, head+g_iconHeight+head, head+newHeight*i+fontOffset, (LPCSTR)wList[i].name, strlen(wList[i].name));
		}
	}
	SelectObject(hdc, hFontOld);
	DeleteObject(hFont);
	DeleteObject(hFontHigh);
	EndPaint(hWnd, &paint);
	return;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg) {
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_PAINT:
			showWinList(hWnd);
			break;
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDM_SETFOREGROUND:
					SetForeground(wList[wListCnt].hWnd);
//					MessageBox(NULL, wList[wListCnt].name, "SetFore", MB_OK);
					LogStatus();
					break;
				default:
					break;
			}
			break;
		case WM_SHOWWINDOW:
			if (LOWORD(wp) == 1) {
				if (LOWORD(lp) == SW_PARENTOPENING) {
					SetFocus(hWnd);
				}
			}
			break;
		default:
			return DefWindowProc(hWnd, msg, wp, lp);
	}
	return 0L;
}

int WINAPI winMain()
{
	WNDCLASS myWin;
	MSG msg;
	myWin.style			= CS_HREDRAW | CS_VREDRAW;
	myWin.lpfnWndProc	= WndProc;
	myWin.cbClsExtra	= 0;
	myWin.cbWndExtra	= 0;
	myWin.hInstance		= g_hInst;
	myWin.hIcon			= NULL;
	myWin.hCursor		= LoadCursor(NULL, IDC_ARROW);
	myWin.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	myWin.lpszMenuName	= NULL;
	myWin.lpszClassName	= WND_CLASS;
	if (!RegisterClass(&myWin)) {
		return FALSE;
	}
	g_hWnd = CreateWindowEx(WS_EX_PALETTEWINDOW | WS_EX_CLIENTEDGE,
		WND_CLASS,
		WND_CLASS,
		WS_POPUP,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		g_winWidth,
		g_winHeight,
		NULL,
		NULL,
		g_hInst,
		NULL);
	ShowWindow(g_hWnd, SW_HIDE);
	UpdateWindow(g_hWnd);
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

static DWORD WINAPI ThreadFunc(LPVOID lp)
{
	return winMain();
}

// --------------------------------------------------------
//    vOC[hꂽƂɌĂ΂
// --------------------------------------------------------
BOOL Init(void)
{
	char iniFile[MAX_PATH];
	GetModuleFileName(g_hInst, iniFile, MAX_PATH);
	PathRenameExtension(iniFile, ".ini");
	g_waitTime = GetPrivateProfileInt("SETTING", "WAITTIME", 500, iniFile);
	DWORD VK_SW = GetPrivateProfileInt("SETTING", "BUTTON1", 1, iniFile);
	DWORD t_isLog = GetPrivateProfileInt("SETTING", "LOG", 0, iniFile);
	g_isClick = GetPrivateProfileInt("SETTING", "CLICK", 1, iniFile);
	g_isWheel = GetPrivateProfileInt("SETTING", "WHEELCLICK", 1, iniFile);
	g_fontHeight = GetPrivateProfileInt("SETTING", "FONTHEIGHT", g_fontHeight, iniFile);
	g_iconHeight = GetPrivateProfileInt("SETTING", "ICONHEIGHT", g_iconHeight, iniFile);
	if (VK_SW == 1) {	//Left
		g_WM_sBUTTONDOWN = WM_LBUTTONDOWN;
		g_WM_sBUTTONUP = WM_LBUTTONUP;
		g_WM_eBUTTONDOWN = WM_RBUTTONDOWN;
		g_WM_eBUTTONUP = WM_RBUTTONUP;
	} else {			//Right
		g_WM_sBUTTONDOWN = WM_RBUTTONDOWN;
		g_WM_sBUTTONUP = WM_RBUTTONUP;
		g_WM_eBUTTONDOWN = WM_LBUTTONDOWN;
		g_WM_eBUTTONUP = WM_LBUTTONUP;
	}
	if (t_isLog == 1) {
		g_isLog = TRUE;
	} else {
		g_isLog = FALSE;
	}
	char temp[1024];
	sprintf(temp, "Init\nwaitTime=%d\nsButton=%x,eButton=%x(LDOWN=%x,RDOWN=%x)", g_waitTime, g_WM_sBUTTONDOWN, g_WM_eBUTTONDOWN, WM_LBUTTONDOWN, WM_RBUTTONDOWN);
	Log(temp);
	
	g_hMouseHook = SetWindowsHookEx(WH_MOUSE_LL, LowLevelMouseProc, g_hInst, 0);
	if (g_hMouseHook == NULL) {
		MessageBox(NULL, "Hooks", PLUGIN_NAME, MB_OK);
		return FALSE;
	}
	g_hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (g_hThread == NULL) {
		g_hThread = CreateThread(NULL, 0, ThreadFunc, 0, 0, &g_ThreadID);
		if (g_hThread == NULL) {
			return FALSE;
		}
	}
	return TRUE;
}

// --------------------------------------------------------
//    vOCA[hꂽƂɌĂ΂
// --------------------------------------------------------
void Unload(void)
{
	Log("Unload");
	if (g_isMouse) {
		g_isMouse = FALSE;
	}
	UnhookWindowsHookEx(g_hMouseHook);
	g_hMouseHook = NULL;
	if (!CloseHandle(g_hEvent)) Log("Error:CloseHandle(g_hEvent)");
	g_hEvent = NULL;
	if (g_hThread != NULL) {
//		WaitForSingleObject(g_hThread, INFINITE);
		g_ThreadID = NULL;
		SendMessage(g_hWnd, WM_CLOSE, 0, 0);
//		if (!DestroyWindow(g_hWnd)) {
//			Log("Error:DestroyWindow");
//		}
		if (!CloseHandle(g_hThread)) Log("Error:CloseHandle(g_hThread)");
		g_hThread = NULL;
		if (!UnregisterClass(WND_CLASS, g_hInst)) {
			Log("Error:UnregisterClass");
		}
	}
	Log("UnloadComplete");
}

// --------------------------------------------------------
//    R}hsɌĂ΂
// --------------------------------------------------------
BOOL Execute(int CmdId, HWND hWnd)
{
	switch (CmdId) {
	case COMMAND1_ID:
		if(g_hMouseHook == NULL)
			Init();
		else
			Unload();
		break;
	}
	return TRUE;
}

// --------------------------------------------------------
//    O[otbNbZ[WĂ
// --------------------------------------------------------
void Hook(UINT Msg, DWORD wParam, DWORD lParam)
{
}


// --------------------------------------------------------
//    DLLMain
// --------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	g_hInst = hinst;
	return 1;
}
#endif

#if _MSC_VER > 1000
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
	return TRUE;
}
#endif

